//+------------------------------------------------------------------+
//|                                                       Bezier.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern double Lots = 0.01;
extern int    sl = 25;
extern int    tp = 60;
extern int    TrailingStop = 20;
extern int    TrailingStep = 5;
extern int    Inc = 4;
extern int    martin = 1;
extern int    Mag = 1;
extern string        StartTime       = "17:00"; //    
extern string        EndTime       = "9:00"; //             
extern int     Period1  = 10;
extern double  t1       = 0.10;
int            Shift1   = 0;
int            Price1   = 0;

extern int     Period2  = 12;
extern double  t2       = 0.12;
int            Shift2   = 0;
int            Price2   = 0;

bool   UseSound      = True;         //   
string NameFileSound = "expert.wav"; //   


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double b1 = iCustom(NULL,PERIOD_H1,"Bezier_orig",Period1,t1,Shift1,Price1,0,1);
   double b2 = iCustom(NULL,PERIOD_H1,"Bezier_orig",Period2,t2,Shift2,Price2,0,1);
   double b3 = iCustom(NULL,PERIOD_H1,"Bezier_orig",Period1,t1,Shift1,Price1,0,2);
  double b4 = iCustom(NULL,PERIOD_H1,"Bezier_orig",Period2,t2,Shift2,Price2,0,2);
  double ma1 = iMA(NULL,PERIOD_H1,3,0,MODE_EMA,PRICE_MEDIAN,0);
  double ma2 = iMA(NULL,PERIOD_H1,3,0,MODE_EMA,PRICE_MEDIAN,1);
  double ma3 = iMA(NULL,PERIOD_M15,3,0,MODE_EMA,PRICE_MEDIAN,0);
  double ma4 = iMA(NULL,PERIOD_M15,3,0,MODE_EMA,PRICE_MEDIAN,1);
  double ma5 = iMA(NULL,PERIOD_M5,3,0,MODE_EMA,PRICE_MEDIAN,0);
  double ma6 = iMA(NULL,PERIOD_M5,3,0,MODE_EMA,PRICE_MEDIAN,1);
   double ma7 = iMA(NULL,PERIOD_H1,4,0,MODE_EMA,PRICE_MEDIAN,0);
   double ma8 = iMA(NULL,PERIOD_H1,4,0,MODE_EMA,PRICE_MEDIAN,1);
  
   int all=OrdersTotal(), total=0, BuyOrders=0, SellOrders=0;
   for(int i=0; i <= all-1; i++)
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol()==Symbol() && OrderMagicNumber()==Mag) 
   total++;
   if(OrderType()==OP_BUY) BuyOrders++;
   if(OrderType()==OP_SELL) SellOrders++;
   }
  double pBid, pAsk, pp, SL, sp = MathAbs(Ask - Bid);

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if ((pBid-OrderOpenPrice())>TrailingStop*pp) {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) {
      if((Bid - OrderOpenPrice()) > pBid-(TrailingStop+TrailingStep-1)*pp) SL=TrailingStop;
        ModifyStopLoss(pBid-SL*pp);
        return;
      }
    }
  }
  
  if (OrderType()==OP_SELL) {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (OrderOpenPrice()-pAsk>sl*pp) {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) {
      if((OrderOpenPrice()-pAsk) > (TrailingStop+TrailingStep-1)*pp) SL=TrailingStop;
        ModifyStopLoss(pAsk+SL*pp);
        return;
      }
    }
  }
  bool trigger1=(CurTime()>=StrToTime(StartTime)&& CurTime()<=StrToTime(EndTime)) ;
    
   if(trigger1)
 {
  double result=iAC(NULL, PERIOD_M15, 1);
   if(total < 1 && (result > 0.0004 || result < -0.0004))
   {
      if(b3 > b4 && b1 < b2 && ma8 < b3 && ma7 > b1)
      {
      OrderSend(Symbol(),OP_SELL, LotSet(), Bid, 0, Bid + sl*Point, Bid - tp*Point,"",Mag,0,Red);
      return(0);
      }
      if(b3 < b4 && b1 > b2 && ma8 > b3 && ma7 < b1)
      {
      OrderSend(Symbol(), OP_BUY, LotSet(), Ask, 0, Ask - sl*Point, Ask + tp*Point, "", Mag, Blue);
      return(0);
      }
    }  
   }  
//----
   return(0);
  }

void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
  if (fm && UseSound) PlaySound(NameFileSound);
}

 double LotSet()
{

 double lot=MinLot(), pl;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0, profit=0, n=0, p=0;                  // number of losses orders without a break
//---- select lot size
  double pr=0;
datetime oct;
double oop,ocp;
int pos_type=-1;
int j=-1;
if(OrdersHistoryTotal()!=0){
for(int i=OrdersHistoryTotal()-1;i>=0;i--){
   if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) continue;  
   if(OrderSymbol()!=Symbol())continue;
   { 
   if (oct<OrderCloseTime()) { oct=OrderCloseTime(); j=i;}           
   if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) 
      {
      pr = OrderProfit();
      pl = OrderLots();
      if(pr < 0)
      {
   if(pl*2 >= MathPow(2,Inc)*MinLot())
   {
   lot = pl;
   }
   else
   {
   if(martin ==1) lot = pl+MinLot()/2;
   if(martin ==2) lot = pl+MinLot();
   if(martin ==3) lot = pl*2;
   }
   }
   else
   {
   lot = MinLot();
   }
   }
   }
   }
    return(lot);
  }
         
     
//---- return lot size

   return(lot);
  }
  
  double MinLot()
  {
  double lot = NormalizeDouble(AccountFreeMargin()/20000,2);
  if(lot < 0.01) lot=0.01;
  return(lot);
  }